/*
PolyGun

Copyright (c) 2023 mrkubax10 <mrkubax10@onet.pl>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#include "common/resource_id_parser.hpp"

#include <vector>

#include "common/logger.hpp"

using namespace polygun::utils;

ResourceIDParser::ResourceIDParser() :
	m_mod_name(),
	m_resource_type(),
	m_resource_name(),
	m_resource_path(),
	m_resource_folder(),
	m_resource_subpath()
{}

bool ResourceIDParser::parse(const std::string& resource_id) {
	// Determine if name is a valid resource ID
	std::vector<std::string> elements;
	std::string current_element;
	for(char ch : resource_id) {
		if(ch=='/' && !current_element.empty()) {
			elements.push_back(current_element);
			current_element.clear();
		}
		else
			current_element+=ch;
	}
	if(!current_element.empty())
		elements.push_back(current_element);
	if(elements.size()!=3) {
		LOG_ERROR("'%s' is not a valid resource ID", resource_id.c_str());
		return false;
	}

	m_mod_name = elements[0];
	m_resource_path = elements[0];
	// Determine resource folder
	m_resource_type = elements[1];
	if(m_resource_type=="texture") {
		m_resource_path+="/textures/";
		m_resource_subpath = "textures/";
	}
	// TODO: Add other resource types
	// Add resource filename to path
	m_resource_folder = m_resource_path;
	m_resource_path+=elements[2];
	m_resource_name = elements[2];
	m_resource_subpath+=m_resource_name;
	if(m_resource_type=="texture") {
		m_resource_path+=".png";
		m_resource_subpath+=".png";
	}

	return true;
}
